#include "auto_update_window.h"
//
extern GtkWidget *auto_update_window;
extern GtkWidget *manual_update_window;
extern GtkWidget *patch_update_window;


static char * book_open_xpm[] = {                                                                                                                               
	"16 16 4 1",
	" c None s None",
	". c black",
	"X c #808080",
	"o c white",
	" ",
	" .. ",
	" .Xo. ... ",
	" .Xoo. ..oo. ",
	" .Xooo.Xooo... ",
	" .Xooo.oooo.X. ",
	" .Xooo.Xooo.X. ",
	" .Xooo.oooo.X. ",
	" .Xooo.Xooo.X. ",
	" .Xooo.oooo.X. ",
	" .Xoo.Xoo..X. ",
	" .Xo.o..ooX. ",
	" .X..XXXXX. ",
	" ..X....... ",
	" .. ",
	" "};

static gint cancel_update()
{
	GtkWidget *dialog;
	if (system("/usr/share/system-update/update-system-cron.sh stop") != 0)
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"取消更新，请检查重试!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
	}
	else
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"取消更新成功！");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
	}
	
    return TRUE; //注意必须为TRUE，否则子窗口点击关闭按钮后，就摧毁了，而不是隐藏了。
}

static gint delete_event()
{
    gtk_widget_hide_all(auto_update_window);

    return TRUE; //注意必须为TRUE，否则子窗口点击关闭按钮后，就摧毁了，而不是隐藏了。
}

GtkWidget* create_title (GtkWidget *data)
{ //创建框架控件的标题
	GtkWindow *title;
	GtkWidget *hbox;
	GtkWidget *image;
	GtkWidget *label;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	pixmap = gdk_pixmap_create_from_xpm_d(
			data->window,&mask,
			&GTK_WIDGET(data)->style->white,
			book_open_xpm);
	image = gtk_image_new_from_pixmap(pixmap,NULL);
	label = gtk_label_new("注意：");
	hbox = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(hbox),image,FALSE,FALSE,2);
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,2);
	return hbox ;
}

static void auto_update()
{
	GtkWidget *dialog;

	if (system("apt-get upgrade -y ") != 0)
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"更新失败，请检查重试!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
	}
	else
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"更新成功，祝您体验愉快!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		system("/usr/share/system-update/change_version.sh");
		system("/usr/share/system-update/update-system-cron.sh start");
		system("echo "" > /usr/share/system-update/auto-update-flag");
	}

	return ;	
}


GtkWidget *create_auto_window()
{
	GtkWidget *cancel;
	GtkWidget *cancelupdate;
	GtkWidget *label;
	GtkWidget *dialog;
	GtkWidget *frame;
	GtkWidget *ok;
	GtkWidget *hbox;
	GtkWidget *title;
	GtkWidget *image;
	GtkWidget *bbox;
	GtkWidget *vbox;

	auto_update_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(auto_update_window), "自动更新");
	gtk_window_set_default_size(GTK_WINDOW(auto_update_window), 300, 200);
	gtk_window_set_position(GTK_WINDOW(auto_update_window), GTK_WIN_POS_CENTER);

	gtk_window_set_icon(GTK_WINDOW(auto_update_window), create_pixbuf("/usr/share/system-update/system-logo-icon.png"));

   vbox = gtk_vbox_new(FALSE,0);
   gtk_container_add(GTK_CONTAINER(auto_update_window),vbox);
   hbox = gtk_hbox_new(FALSE,0);
   gtk_box_pack_start(GTK_BOX(vbox),hbox,TRUE,TRUE,5);

   image = gtk_image_new_from_file("/usr/share/system-update/system-logo-icon.png");
   gtk_box_pack_start(GTK_BOX(hbox),image,FALSE,FALSE,5);

   frame = gtk_frame_new(NULL);
   title = create_title(auto_update_window);
   gtk_frame_set_label_widget(GTK_FRAME(frame),title);
   gtk_box_pack_start(GTK_BOX(hbox),frame,TRUE,TRUE,5);

   label = gtk_label_new(NULL);

   gtk_label_set_text(GTK_LABEL(label),"自动更新设置成功,更新过程中,请勿当前窗口关闭!!!\n");
   gtk_label_set_line_wrap(GTK_LABEL(label),TRUE);
   gtk_container_add(GTK_CONTAINER(frame),label);
   bbox = gtk_hbutton_box_new();

   gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox),GTK_BUTTONBOX_END);
   gtk_box_set_spacing(GTK_BOX(bbox),5);
   gtk_box_pack_start(GTK_BOX(vbox),bbox,FALSE,FALSE,5);

   cancelupdate = gtk_button_new_with_label("取消自动更新");
   gtk_box_pack_start(GTK_BOX(bbox), cancelupdate, FALSE, FALSE, 5);
	
	cancel = gtk_button_new_with_label("取消");
   gtk_box_pack_start(GTK_BOX(bbox), cancel, FALSE, FALSE, 5);


   ok = gtk_button_new_with_label("确定");
   gtk_box_pack_start(GTK_BOX(bbox), ok, FALSE, FALSE, 5);

   g_signal_connect(G_OBJECT(ok),"clicked", G_CALLBACK(auto_update),NULL);
   g_signal_connect(G_OBJECT(cancel),"clicked", G_CALLBACK(delete_event),NULL);
   g_signal_connect(G_OBJECT(cancelupdate),"clicked", G_CALLBACK(cancel_update),NULL);

   g_signal_connect(G_OBJECT(auto_update_window),"delete_event",G_CALLBACK(delete_event), NULL); //注意这里不是“destroy” 事件

	return auto_update_window;
}

