#include "common.h"

GdkPixbuf *create_pixbuf(const gchar * filename)
{
    GdkPixbuf *pixbuf;
    GError *error = NULL;

    pixbuf = gdk_pixbuf_new_from_file(filename, &error);
    if(!pixbuf) {
        fprintf(stderr, "%s\n", error->message);
        g_error_free(error);
    }
    return pixbuf;
}


void toggle_display(GtkWidget *widget, gpointer oneofwidget)
{
    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(widget))) {
        gtk_widget_show(oneofwidget);
    } else {
        gtk_widget_hide(oneofwidget);
    }
}

int file_empty(char *filename)
{
	int flag = 0;
	FILE *fp;

	if ((fp = fopen(filename, "r")) == NULL)
		return 1;

	if (fgetc(fp) == EOF)
		flag = 1;
	
	fclose(fp);
	return flag;
}


