#include "manual_update_window.h"

#define MODIFY_UPDATE_LIST "/tmp/manual_update.list"
#define UPDATE_LIST	"/usr/share/system-update/update.list"
#define AUTO_UPDATE_FLAG	"/usr/share/system-update/auto-update-flag"

extern GtkWidget *manual_update_window;


enum
{
  LIST_ITEM = 0,
  N_COLUMNS
};

static GtkWidget *list;
static int flag = 0;

static gint delete_event()
{
    gtk_widget_hide_all(manual_update_window);

    return TRUE; //注意必须为TRUE，否则子窗口点击关闭按钮后，就摧毁了，而不是隐藏了。
}

static void append_item(GtkWidget *widget, gpointer selection)
{
	FILE *fp;
	GtkListStore *store;
	GtkTreeIter  iter;
	char package[64] = {0};

	if ((fp = fopen(UPDATE_LIST, "r")) == NULL)
		return ;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
	while (fgets(package, 64, fp) != NULL)
	{
		package[strlen(package)-1] = '\0';
//		if (package[strlen(package)-1] == '\r')
//			package[strlen(package)-1] = '\0';

		gtk_list_store_append(store, &iter);
		gtk_list_store_set(store, &iter, LIST_ITEM, package, -1);
		bzero(package, sizeof(package));
	}

	fclose(fp);
}

static void remove_all(GtkWidget *widget, gpointer selection)
{
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;
	GtkWidget *dialog;
	gint response = GTK_RESPONSE_CANCEL;

		store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_NONE,
				"列表为空提醒");

		gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
				"当前更新列表已为空,是否需要刷新!\n如果取消，请也可重试!");

		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
				"取消", GTK_RESPONSE_CANCEL,
				"确定", GTK_RESPONSE_YES,
				NULL);
		gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_YES);

		response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		
		if (response == GTK_RESPONSE_YES)
		{
			append_item(manual_update_window, selection);	
		}
		else
			return;
	}
	else
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"移除所有后再点击移除所有即可刷新！");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);


	}
	if (response != GTK_RESPONSE_YES)
		gtk_list_store_clear(store);
}

static void remove_item(GtkWidget *widget, gpointer selection)
{
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;
	GtkWidget *dialog;
	gint response;


	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_NONE,
				"列表为空提醒");

		gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
				"当前更新列表已为空,是否需要刷新!\n如果取消，请退出重试!");

		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
				"取消", GTK_RESPONSE_CANCEL,
				"确定", GTK_RESPONSE_YES,
				NULL);
		gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_YES);

		response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		
		if (response == GTK_RESPONSE_YES)
			append_item(manual_update_window, selection);	
		else
			return;
	}

	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter))
	{
		gtk_list_store_remove(store, &iter);
	}

	if (gtk_tree_model_iter_next(model, &iter) == FALSE && gtk_tree_model_get_iter_first(model, &iter) == FALSE)
	{

		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_NONE,
				"温馨提醒");

		gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
				"是否需要再次刷新列表，如点击取消之后再点击移除即可刷新！");

		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
				"取消", GTK_RESPONSE_CANCEL,
				"确定", GTK_RESPONSE_YES,
				NULL);
		gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_YES);

		response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		
		if (response == GTK_RESPONSE_YES)
			append_item(manual_update_window, selection);	
		else
			return;
	}
}

static void patch_update (GtkWidget *widget, gpointer selection)
{
	GtkWidget *dialog;
	GtkTreeIter iter;
  	GtkTreeModel *model;
	GtkListStore *store;
	char *value;
	FILE *fp;
	gint response;
	
	if (!access(AUTO_UPDATE_FLAG, F_OK) || access(UPDATE_LIST, F_OK))
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"当前已是最新系统！");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	
	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE)
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"当前已是最新系统!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		return;
	}
	if ((fp = fopen("/tmp/manual_update.list", "w")) == NULL)
		return;
	fputs("apt-get install -y ", fp);
	do
	{
		gtk_tree_model_get(model, &iter, LIST_ITEM, &value,  -1);
		printf("value = %s\n", value);
		fputs(value, fp);	
		fputs(" ",fp);
		g_free(value);

	}while(gtk_tree_model_iter_next(model, &iter));
	
	fputs("\napt-get install -f -y\n", fp);
	fclose(fp);

	dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_QUESTION,
			GTK_BUTTONS_NONE,
			"更新提醒");

	gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
			"请确认更新，更新时，请勿关闭电脑!");

	gtk_dialog_add_buttons (GTK_DIALOG (dialog),
			"取消", GTK_RESPONSE_CANCEL,
			"确定", GTK_RESPONSE_YES,
			NULL);
	gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_CANCEL);

	response = gtk_dialog_run (GTK_DIALOG (dialog));
	gtk_widget_destroy (dialog);

	if (response == GTK_RESPONSE_CANCEL)
		return ;


	if (response != -4)
	{
		if (system("/bin/bash /tmp/manual_update.list") != 0)
		{
			dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
					GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
					GTK_MESSAGE_INFO,
					GTK_BUTTONS_OK,
					"更新失败，请检查重试!");
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			return;
		}

		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"更新成功，祝您体验愉快!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		gtk_list_store_clear(store);
		system("rm -fr /usr/share/system-update/update.list");
		system("rm -fr /usr/share/system-update/update-package");
		system("/usr/share/system-update/change_version.sh");
	}
	return;
}

static void init_list(GtkWidget *list)
{

	GtkCellRenderer    *renderer;
	GtkTreeViewColumn  *column;
	GtkListStore       *store;

	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes("List Item",
			renderer, "text", LIST_ITEM, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW (list), column);

	store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING);

	gtk_tree_view_set_model(GTK_TREE_VIEW (list), GTK_TREE_MODEL(store));

	g_object_unref(store);
}

GtkWidget *create_manual_window()
{
	GtkWidget *sw;

	GtkWidget *remove;
	GtkWidget *removeAll;
	GtkWidget *update;

	GtkWidget *vbox;
	GtkWidget *hbox;

	GtkTreeSelection *selection; 

	manual_update_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);


	sw = gtk_scrolled_window_new(NULL, NULL);
	list = gtk_tree_view_new();

	gtk_window_set_title (GTK_WINDOW (manual_update_window), "手动更新");
	gtk_window_set_position(GTK_WINDOW(manual_update_window), GTK_WIN_POS_CENTER);
	gtk_container_set_border_width (GTK_CONTAINER (manual_update_window), 10);
	gtk_widget_set_size_request (manual_update_window, 800, 700);

	gtk_window_set_icon(GTK_WINDOW(manual_update_window), create_pixbuf("/usr/share/system-update/system-logo-icon.png"));

	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);

	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (list), FALSE);

	vbox = gtk_vbox_new(FALSE, 0);

	gtk_box_pack_start(GTK_BOX(vbox), sw, TRUE, TRUE, 5);

	hbox = gtk_hbox_new(TRUE, 5);

	remove = gtk_button_new_with_label("移除");
	removeAll = gtk_button_new_with_label("移除所有");
	update = gtk_button_new_with_label("更新");

	gtk_box_pack_start(GTK_BOX(hbox), remove, FALSE, TRUE, 3);
	gtk_box_pack_start(GTK_BOX(hbox), removeAll, FALSE, TRUE, 3);
	gtk_box_pack_start(GTK_BOX(hbox), update, FALSE, TRUE, 3);

	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 3);

	gtk_container_add(GTK_CONTAINER (sw), list);
	gtk_container_add(GTK_CONTAINER (manual_update_window), vbox);

	init_list(list);

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
	
	append_item(manual_update_window, selection);	

	g_signal_connect(G_OBJECT(removeAll), "clicked", G_CALLBACK(remove_all), selection);

	g_signal_connect(G_OBJECT(remove), "clicked", G_CALLBACK(remove_item), selection);

	g_signal_connect(G_OBJECT(update), "clicked", G_CALLBACK(patch_update), selection);

	g_signal_connect(G_OBJECT(manual_update_window),"delete_event", G_CALLBACK(delete_event), NULL); 

	return manual_update_window;
}
