#include "patch_update_window.h"

//#define PATCH_UPDATE_LIST "/usr/share/system-update/patch_update.list"
#define PATCH_UPDATE_LIST "/tmp/patch_update"


extern GtkWidget *patch_update_window;


enum
{
  LIST_ITEM = 0,
  N_COLUMNS
};

static GtkWidget *list, *file;

static gint delete_event()
{
    gtk_widget_hide_all(patch_update_window);

    return TRUE; //注意必须为TRUE，否则子窗口点击关闭按钮后，就摧毁了，而不是隐藏了。
}

static void file_OK(GtkWidget *w)
{	
	GtkListStore *store;
	GtkTreeIter  iter;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));

	gtk_list_store_append(store, &iter);
	gtk_list_store_set(store, &iter, LIST_ITEM, gtk_file_selection_get_filename(GTK_FILE_SELECTION(file)), -1);
   	gtk_widget_destroy (file);

}

static void append_item(GtkWidget *widget, gpointer selection)
{
	file = gtk_file_selection_new ("选择需要更新的软件包");

	g_signal_connect (G_OBJECT (GTK_FILE_SELECTION (file)->ok_button), "clicked",
			G_CALLBACK (file_OK), selection);
	g_signal_connect_swapped (G_OBJECT (GTK_FILE_SELECTION (file)->cancel_button), "clicked",
			G_CALLBACK (gtk_widget_destroy), file);
    gtk_widget_show (file);
}

static void remove_item(GtkWidget *widget, gpointer selection)
{
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;


	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;

	if (gtk_tree_selection_get_selected(GTK_TREE_SELECTION(selection), &model, &iter))
	{
		gtk_list_store_remove(store, &iter);
	}
}

static void remove_all(GtkWidget *widget, gpointer selection)
{
	GtkListStore *store;
	GtkTreeModel *model;
	GtkTreeIter  iter;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE) 
		return;
	gtk_list_store_clear(store);
}

static void patch_update (GtkWidget *widget, gpointer selection)
{
	GtkWidget *dialog;
	GtkTreeIter iter;
	GtkListStore *store;
	GtkTreeModel *model;
	char *value;
	FILE *fp;
	gint response;

	store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW (list)));
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (list));

	if (gtk_tree_model_get_iter_first(model, &iter) == FALSE)
	{

		dialog = gtk_message_dialog_new(GTK_WINDOW (patch_update_window),
				GTK_DIALOG_MODAL,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_NONE,
				"列表为空提醒");

		gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
				"当前更新列表已为空,是否需要刷新!\n如果取消，请退出重试!");

		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
				"确定", GTK_RESPONSE_YES,
				NULL);
		gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_YES);

		response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);

		return;
	}
	if ((fp = fopen(PATCH_UPDATE_LIST, "w")) == NULL)
		return;
	fputs("function install-package() \n{\n \tdpkg -i ", fp);
	do
	{
		gtk_tree_model_get(model, &iter, LIST_ITEM, &value,  -1);
		printf("value = %s\n", value);
		fputs(value, fp);	
		fputs(" ",fp);
		g_free(value);

	}while(gtk_tree_model_iter_next(model, &iter));
	fputs("\n}\n install-package\n apt-get install -f -y\n install-package\n",fp);

	fclose(fp);

	dialog = gtk_message_dialog_new(GTK_WINDOW (patch_update_window),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_QUESTION,
			GTK_BUTTONS_NONE,
			"更新提醒");

	gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
			"请确认更新，更新时，请勿关闭电脑!");

	gtk_dialog_add_buttons (GTK_DIALOG (dialog),
			"取消", GTK_RESPONSE_CANCEL,
			"确定", GTK_RESPONSE_YES,
			NULL);
	gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_CANCEL);

	response = gtk_dialog_run (GTK_DIALOG (dialog));
	gtk_widget_destroy (dialog);

	if (response == GTK_RESPONSE_CANCEL)
		return ;

	if(response != -4)
	{
		if (system("/bin/bash /tmp/patch_update") != 0)
		{
			dialog = gtk_message_dialog_new(GTK_WINDOW (patch_update_window),
					GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
					GTK_MESSAGE_INFO,
					GTK_BUTTONS_OK,
					"更新失败，请检查重试!");
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			return;
		}

		dialog = gtk_message_dialog_new(GTK_WINDOW (patch_update_window),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"更新成功，祝您体验愉快!");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		gtk_list_store_clear(store);
	}
	return;
}

static void init_list(GtkWidget *list)
{

	GtkCellRenderer    *renderer;
	GtkTreeViewColumn  *column;
	GtkListStore       *store;

	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes("List Item",
			renderer, "text", LIST_ITEM, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW (list), column);

	store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING);

	gtk_tree_view_set_model(GTK_TREE_VIEW (list), GTK_TREE_MODEL(store));

	g_object_unref(store);
}


GtkWidget *create_patch_window()
{
	GtkWidget *sw;

	GtkWidget *remove;
	GtkWidget *add;
	GtkWidget *removeAll;
	GtkWidget *update;

	GtkWidget *vbox;
	GtkWidget *hbox;

	GtkTreeSelection *selection; 

	patch_update_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	sw = gtk_scrolled_window_new(NULL, NULL);
	list = gtk_tree_view_new();

	gtk_window_set_title (GTK_WINDOW (patch_update_window), "补丁更新");
	gtk_window_set_position(GTK_WINDOW(patch_update_window), GTK_WIN_POS_CENTER);
	gtk_container_set_border_width (GTK_CONTAINER (patch_update_window), 10);
	gtk_widget_set_size_request (patch_update_window, 800, 700);

	gtk_window_set_icon(GTK_WINDOW(patch_update_window), create_pixbuf("/usr/share/system-update/system-logo-icon.png"));

	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW(sw), GTK_SHADOW_ETCHED_IN);

	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (list), FALSE);

	vbox = gtk_vbox_new(FALSE, 0);

	gtk_box_pack_start(GTK_BOX(vbox), sw, TRUE, TRUE, 5);

	hbox = gtk_hbox_new(TRUE, 5);

	add = gtk_button_new_with_label("添加");
	remove = gtk_button_new_with_label("移除");
	removeAll = gtk_button_new_with_label("移除所有");
	update = gtk_button_new_with_label("更新");

	gtk_box_pack_start(GTK_BOX(hbox), add, FALSE, TRUE, 3);
	gtk_box_pack_start(GTK_BOX(hbox), remove, FALSE, TRUE, 3);
	gtk_box_pack_start(GTK_BOX(hbox), removeAll, FALSE, TRUE, 3);
	gtk_box_pack_start(GTK_BOX(hbox), update, FALSE, TRUE, 3);

	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 3);

	gtk_container_add(GTK_CONTAINER (sw), list);
	gtk_container_add(GTK_CONTAINER (patch_update_window), vbox);

	init_list(list);

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));

	g_signal_connect(G_OBJECT(add), "clicked", G_CALLBACK(append_item), selection);

	g_signal_connect(G_OBJECT(remove), "clicked", G_CALLBACK(remove_item), selection);

	g_signal_connect(G_OBJECT(removeAll), "clicked", G_CALLBACK(remove_all), selection);

	g_signal_connect(G_OBJECT(update), "clicked", G_CALLBACK(patch_update), selection);

	g_signal_connect(G_OBJECT(patch_update_window),"delete_event", G_CALLBACK(delete_event), NULL); 

	return patch_update_window;
}
