#include <gtk/gtk.h>
#include "common.h"
#include "window_main.h"

#include "auto_update_window.h"
#include "manual_update_window.h"
#include "patch_update_window.h"

#define UPDATE_FILE "/usr/share/system-update/update-package"

//Global
GtkWidget *auto_update_window = NULL;  //子窗口本身
GtkWidget *manual_update_window = NULL;  //子窗口本身
GtkWidget *patch_update_window = NULL;  //子窗口本身


int main( int argc, char *argv[])
{
    GtkWidget *window_main;
    GtkWidget *dialog;
    gint response;

    gtk_init(&argc, &argv);

    window_main = create_main_window(); //创建主窗口

	if (getuid() != 0)
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (window_main),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"更新系统需要使用root用户，请切换至root用户");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		gtk_main_quit();

		return -1;
	}
	
	if (system("/usr/share/system-update/update.sh") != 0)
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (window_main),
				GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
				GTK_MESSAGE_INFO,
				GTK_BUTTONS_OK,
				"获取更新源失败，请检查重试！");
		gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		gtk_main_quit();
		return -1;
	}

	if (file_empty(UPDATE_FILE))
	{
		dialog = gtk_message_dialog_new(GTK_WINDOW (manual_update_window),
				GTK_DIALOG_MODAL,
				GTK_MESSAGE_QUESTION,
				GTK_BUTTONS_NONE,
				"最新提醒");

		gtk_message_dialog_format_secondary_markup (GTK_MESSAGE_DIALOG (dialog),
				"当前系统已为最新系统");

		gtk_dialog_add_buttons (GTK_DIALOG (dialog),
				"补丁更新", GTK_RESPONSE_CANCEL,
				"确定", GTK_RESPONSE_YES,
				NULL);
		gtk_dialog_set_default_response (GTK_DIALOG (dialog), GTK_RESPONSE_YES);

		response = gtk_dialog_run (GTK_DIALOG (dialog));
		gtk_widget_destroy (dialog);
		
		if (response == GTK_RESPONSE_YES)
		{
			gtk_main_quit();
			return -1;
		}
	}


    manual_update_window = create_manual_window(); //创建手动更新窗口
    auto_update_window = create_auto_window(); //创建手动更新窗口
    patch_update_window = create_patch_window(); //创建手动更新窗口

    gtk_widget_show_all(window_main); //显示主窗口

    gtk_main();
    return 0;

}
